/*****************************************************
 : Omicron
 : 4.0
  : Klingfed
 : 

               : ATtiny45
       : 8 M
          : Tiny
  SRAM  : 0
     : 64
*****************************************************/

#include <tiny45.h>

//   
volatile unsigned char Flag=0;
#include "Box.c"

//    
interrupt [EXT_INT0] void ext_int0_isr(void)
{
 Flag = 1; // 
}

void main(void)
{
//   
unsigned char i=0, j=0, k=0;
unsigned long int Tau=0, Delay=0, n=0;

//   : 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

//   /
//   B
//      B: 5=Out; 4=Out; 3=Out; 2=Out; 1=Out; 0=In; 
// C   B: 5=0; 4=0; 3=0; 2=0; 1=0; 0=T; 
DDRB=0x3E;
PORTB=0x00;

//  / 0
//   :   
//  :  0 
//  : Normal top=FFh
// OC0A : 
// OC0B : 
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

//  / 1
//   :   
//  :  1 
//  : Normal top=FFh
// OC1A : 
// OC1B : 
//   1  : 
//       A: 
//       B: 
PLLCSR=0x00;

TCCR1=0x00;
GTCCR=0x00;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0x00;

//   
// INT0: 
//   INT0:  
//       PCINT0-5: 
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

//    /
TIMSK=0x00;

//     (USI)
//  : 
//   : Register & Counter=no clk.
//   USI  : 
USICR=0x00;

//   
//  : 
ACSR=0x80;
ADCSRB=0x00;

//  
#asm("sei")

while (1){
      Mark: ; //      
       if (Flag==1) { // ,      
        PORTB=0x00; //         
        if (i<=128) { //    
         Delay -= ((128-i)*Delay)>>7; //       
        } else {
         Delay += Tau>>7; //      
        };
       Flag = 0; //  
       };
       
      for (i=0;i<128;i++) {
       PORTB=0x00; //   ,  ,   
       PORTB.3 = 1; //    RESET 
       
       for (j=0;j<8;j++) {
        for (k=0;k<8;k++) {
         PORTB.1 = ((Sparks[i][j]>>k)&(0x01)); //       
         PORTB.2 = 1; //          
         PORTB.2 = 0;
        };
       };
       PORTB.4 = 1; //  
       
       for (n=0;n<Delay;n++) { //       
        if (Flag==1) { // ,      
         goto Mark; //    
        }
       }; 
      };
      
      for (Tau=0;Flag==0;Tau++) { //     
      };

     };
}

